-- Pin by Jadya
-- EU - Well of Eternity
local addonName, addonTable = ...
local L = addonTable.L

local version = 1

addonTable.classes = {"WARRIOR","PALADIN","HUNTER","ROGUE","PRIEST","DEATHKNIGHT","SHAMAN","MAGE","WARLOCK","MONK","DRUID",--[["DEMONHUNTER"]]}
_, addonTable.playerclass = UnitClass("player")

addonTable.settings       = {}
addonTable.NoteFunctions  = {}
addonTable.GroupFunctions = {}

local settings = addonTable.settings
local notes = addonTable.NoteFunctions
local groups = addonTable.GroupFunctions

addonTable.notes = {}
addonTable.active_notes = {}

local eventframe = CreateFrame("Frame")
eventframe:SetScript("OnEvent", function(self, event, ...) self[event](...) end)

eventframe:RegisterEvent("PLAYER_REGEN_DISABLED")
function eventframe.PLAYER_REGEN_DISABLED(...)
 for _,v in pairs(PinSaves.groups) do
  if groups:IsActive(v) then
   for _,n in pairs(v.notes) do
    local note = addonTable.notes[n]
    if note.combat_behavior == 1 then
     note:Hide()
    elseif note.combat_behavior == 2 then
     note.text:EnableMouse(false)
    end
   end
  end
 end
end

eventframe:RegisterEvent("PLAYER_REGEN_ENABLED")
function eventframe.PLAYER_REGEN_ENABLED(...)
 for _,v in pairs(PinSaves.groups) do
  if groups:IsActive(v) then
   for _,n in pairs(v.notes) do
    local note = addonTable.notes[n]
    if note.combat_behavior == 1 then
     note:Show()
    elseif note.combat_behavior == 2 then
     note.text:EnableMouse(true)
    end
   end
  end
 end
end

eventframe:RegisterEvent("VARIABLES_LOADED")
function eventframe.VARIABLES_LOADED(...)
 if PinSaves and (PinSaves.version or 0) < version then
  PinSaves     = nil
  --PinCharSaves = nil
 end

 local pName = UnitName("player")
 local pRealm = GetRealmName()
 addonTable.playername = pName.."-"..pRealm
 
 if not PinSaves            then PinSaves            = {}  end
 if not PinSaves.notes      then PinSaves.notes      = {}  end
 if not PinSaves.groups     then PinSaves.groups     = {}  end
 --if not PinCharSaves        then PinCharSaves        = {}  end
 --if not PinCharSaves.groups then PinCharSaves.groups = {}  end
 
 PinSaves.version = version

 SaregonWidgets:SetButtonsFont("PinButtonsFont")

 groups:ShowActive()
end


-- slash commands

local function SlashCmd()
 for k,v in pairs(PinSaves.groups) do
  groups:Load(v, true)
  groups:Hide(v)
 end
 settings:Mainframe()
end

SLASH_PIN1 = "/pin"
SlashCmdList["PIN"] = SlashCmd


